//
// Implementazione della Classi Impiegati e Manager. Prima versione.
//

#include <iostream.h>
#include <strings.h>

#include "Impiegati1.H"


// Costruttore per il tipo di dato Impiegato.
Impiegato::Impiegato(char *n, int e)
{
  strcpy(nome, n);
  eta = e;
  salario = 1500000;	// Salario di default
}


// Stampa i dati essenziali relativi all'impiegato.
void Impiegato::Print()
{
  cout << nome << endl;
  cout << "L'eta` e` " << eta << endl;
  cout << "Il salario e` " << salario << endl;
}



// Assegna il salario dell'impiegato.
void Impiegato::SetSalario(float s)
{
  salario = s;
}



// Assegna il Dipartimento per l'impiegato.
void Impiegato::SetDip(char *d)
{
  strcpy(dipartimento, d);  
}




// Costruttore per la classe Manager. La lista di inizializzazione invoca il
// costruttore per la classe base Impiegato.
Manager::Manager(char *n, int l, int e):
  Impiegato(n, e)
{
  livello = l;
  numimp = 0;		// Inizialmente non ha impiegati sotto di se.
  salario = 130000000;	// Salario e` un membro Protetto della classe base,
			// quindi posso accederci direttamente.
}


// Ridefinizione della funzione Print per la classe Manager.
void Manager::Print()
{
  cout << "Dott. Ing. Cav. ";

  Impiegato::Print();

  cout << "Il livello e` " << livello << endl;

  cout << "Il suo gruppo di lavoro e` costituito da " 
       << numimp << " Impiegati." << endl;

  cout << "============" << endl;
  for (int i = 0; i < numimp; i++) {
    gruppo[i]->Print();
    cout << "============" << endl;
  }
}


// Aggiunge un impiegato al gruppo di un Manager
void Manager::AddToGrp(Impiegato *i)
{
  gruppo[numimp++] = i;
}
